build-protoc.sh 6.77 KB
Newer Older
1 2
#!/bin/bash

3 4
# Builds protoc executable into target/protoc.exe; optionally build protoc
# plugins into target/protoc-gen-*.exe
5
# To be run from Maven.
Jisi Liu's avatar
Jisi Liu committed
6
# Usage: build-protoc.sh <OS> <ARCH> <TARGET>
7
# <OS> and <ARCH> are ${os.detected.name} and ${os.detected.arch} from os-maven-plugin
Jisi Liu's avatar
Jisi Liu committed
8
# <TARGET> can be "protoc" or "protoc-gen-javalite"
9 10
OS=$1
ARCH=$2
11
MAKE_TARGET=$3
12

13
if [[ $# < 3 ]]; then
14 15 16 17
  echo "No arguments provided. This script is intended to be run from Maven."
  exit 1
fi

18 19 20 21 22 23 24 25 26 27
case $MAKE_TARGET in
  protoc-gen-javalite)
    ;;
  protoc)
    ;;
  *)
    echo "Target ""$TARGET"" invalid."
    exit 1
esac

28 29 30 31 32 33 34 35 36 37
# Under Cygwin, bash doesn't have these in PATH when called from Maven which
# runs in Windows version of Java.
export PATH="/bin:/usr/bin:$PATH"

############################################################################
# Helper functions
############################################################################
E_PARAM_ERR=98
E_ASSERT_FAILED=99

38
# Usage:
39 40
fail()
{
41 42
  echo "ERROR: $1"
  echo
43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60
  exit $E_ASSERT_FAILED
}

# Usage: assertEq VAL1 VAL2 $LINENO
assertEq ()
{
  lineno=$3
  if [ -z "$lineno" ]; then
    echo "lineno not given"
    exit $E_PARAM_ERR
  fi

  if [[ "$1" != "$2" ]]; then
    echo "Assertion failed:  \"$1\" == \"$2\""
    echo "File \"$0\", line $lineno"    # Give name of file and line number.
    exit $E_ASSERT_FAILED
  fi
}
61 62 63 64 65

# Checks the artifact is for the expected architecture
# Usage: checkArch <path-to-protoc>
checkArch ()
{
66
  echo
67
  echo "Checking file format ..."
68 69
  if [[ "$OS" == windows || "$OS" == linux ]]; then
    format="$(objdump -f "$1" | grep -o "file format .*$" | grep -o "[^ ]*$")"
70
    echo Format=$format
71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90
    if [[ "$OS" == linux ]]; then
      if [[ "$ARCH" == x86_32 ]]; then
        assertEq $format "elf32-i386" $LINENO
      elif [[ "$ARCH" == x86_64 ]]; then
        assertEq $format "elf64-x86-64" $LINENO
      else
        fail "Unsupported arch: $ARCH"
      fi
    else
      # $OS == windows
      if [[ "$ARCH" == x86_32 ]]; then
        assertEq $format "pei-i386" $LINENO
      elif [[ "$ARCH" == x86_64 ]]; then
        assertEq $format "pei-x86-64" $LINENO
      else
        fail "Unsupported arch: $ARCH"
      fi
    fi
  elif [[ "$OS" == osx ]]; then
    format="$(file -b "$1" | grep -o "[^ ]*$")"
91
    echo Format=$format
92 93 94 95 96 97 98
    if [[ "$ARCH" == x86_32 ]]; then
      assertEq $format "i386" $LINENO
    elif [[ "$ARCH" == x86_64 ]]; then
      assertEq $format "x86_64" $LINENO
    else
      fail "Unsupported arch: $ARCH"
    fi
99
  else
100
    fail "Unsupported system: $OS"
101
  fi
102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120
  echo
}

# Checks the dependencies of the artifact. Artifacts should only depend on
# system libraries.
# Usage: checkDependencies <path-to-protoc>
checkDependencies ()
{
  if [[ "$OS" == windows ]]; then
    dump_cmd='objdump -x '"$1"' | fgrep "DLL Name"'
    white_list="KERNEL32\.dll\|msvcrt\.dll"
  elif [[ "$OS" == linux ]]; then
    dump_cmd='ldd '"$1"
    if [[ "$ARCH" == x86_32 ]]; then
      white_list="linux-gate\.so\.1\|libpthread\.so\.0\|libm\.so\.6\|libc\.so\.6\|ld-linux\.so\.2"
    elif [[ "$ARCH" == x86_64 ]]; then
      white_list="linux-vdso\.so\.1\|libpthread\.so\.0\|libm\.so\.6\|libc\.so\.6\|ld-linux-x86-64\.so\.2"
    fi
  elif [[ "$OS" == osx ]]; then
121
    dump_cmd='otool -L '"$1"' | fgrep dylib'
122
    white_list="libz\.1\.dylib\|libstdc++\.6\.dylib\|libSystem\.B\.dylib"
123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138
  fi
  if [[ -z "$white_list" || -z "$dump_cmd" ]]; then
    fail "Unsupported platform $OS-$ARCH."
  fi
  echo "Checking for expected dependencies ..."
  eval $dump_cmd | grep -i "$white_list" || fail "doesn't show any expected dependencies"
  echo "Checking for unexpected dependencies ..."
  eval $dump_cmd | grep -i -v "$white_list"
  ret=$?
  if [[ $ret == 0 ]]; then
    fail "found unexpected dependencies (listed above)."
  elif [[ $ret != 1 ]]; then
    fail "Error when checking dependencies."
  fi  # grep returns 1 when "not found", which is what we expect
  echo "Dependencies look good."
  echo
139
}
140 141
############################################################################

142
echo "Building protoc, OS=$OS ARCH=$ARCH TARGET=$TARGET"
143

144 145 146
# Nested double quotes are unintuitive, but it works.
cd "$(dirname "$0")"

147
WORKING_DIR=$(pwd)
148 149
CONFIGURE_ARGS="--disable-shared"

150
TARGET_FILE=target/$MAKE_TARGET.exe
151 152 153 154
if [[ "$OS" == windows ]]; then
  MAKE_TARGET="${MAKE_TARGET}.exe"
fi

155 156 157
# Override the default value set in configure.ac that has '-g' which produces
# huge binary.
CXXFLAGS="-DNDEBUG"
158
LDFLAGS=""
159

160 161 162 163 164 165 166 167 168 169 170 171 172 173
if [[ "$(uname)" == CYGWIN* ]]; then
  assertEq "$OS" windows $LINENO
  # Use mingw32 compilers because executables produced by Cygwin compiler
  # always have dependency on Cygwin DLL.
  if [[ "$ARCH" == x86_64 ]]; then
    CONFIGURE_ARGS="$CONFIGURE_ARGS --host=x86_64-w64-mingw32"
  elif [[ "$ARCH" == x86_32 ]]; then
    CONFIGURE_ARGS="$CONFIGURE_ARGS --host=i686-pc-mingw32"
  else
    fail "Unsupported arch by CYGWIN: $ARCH"
  fi
elif [[ "$(uname)" == MINGW32* ]]; then
  assertEq "$OS" windows $LINENO
  assertEq "$ARCH" x86_32 $LINENO
Kun Zhang's avatar
Kun Zhang committed
174 175 176
elif [[ "$(uname)" == MINGW64* ]]; then
  assertEq "$OS" windows $LINENO
  assertEq "$ARCH" x86_64 $LINENO
177
elif [[ "$(uname)" == Linux* ]]; then
178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197
  if [[ "$OS" == linux ]]; then
    if [[ "$ARCH" == x86_64 ]]; then
      CXXFLAGS="$CXXFLAGS -m64"
    elif [[ "$ARCH" == x86_32 ]]; then
      CXXFLAGS="$CXXFLAGS -m32"
    else
      fail "Unsupported arch: $ARCH"
    fi
  elif [[ "$OS" == windows ]]; then
    # Cross-compilation for Windows
    # TODO(zhangkun83) MinGW 64 always adds dependency on libwinpthread-1.dll,
    # which is undesirable for repository deployment.
    CONFIGURE_ARGS="$CONFIGURE_ARGS"
    if [[ "$ARCH" == x86_64 ]]; then
      CONFIGURE_ARGS="$CONFIGURE_ARGS --host=x86_64-w64-mingw32"
    elif [[ "$ARCH" == x86_32 ]]; then
      CONFIGURE_ARGS="$CONFIGURE_ARGS --host=i686-w64-mingw32"
    else
      fail "Unsupported arch: $ARCH"
    fi
198
  else
199
    fail "Cannot build $OS on $(uname)"
200 201 202
  fi
elif [[ "$(uname)" == Darwin* ]]; then
  assertEq "$OS" osx $LINENO
203 204
  # Make the binary compatible with OSX 10.7 and later
  CXXFLAGS="$CXXFLAGS -mmacosx-version-min=10.7"
205 206 207 208 209 210 211
  if [[ "$ARCH" == x86_64 ]]; then
    CXXFLAGS="$CXXFLAGS -m64"
  elif [[ "$ARCH" == x86_32 ]]; then
    CXXFLAGS="$CXXFLAGS -m32"
  else
    fail "Unsupported arch: $ARCH"
  fi
212 213 214
else
  fail "Unsupported system: $(uname)"
fi
215

216
# Statically link libgcc and libstdc++.
Kun Zhang's avatar
Kun Zhang committed
217 218 219
# -s to produce stripped binary.
# And they don't work under Mac.
if [[ "$OS" != osx ]]; then
220
  LDFLAGS="$LDFLAGS -static-libgcc -static-libstdc++ -s"
Kun Zhang's avatar
Kun Zhang committed
221
fi
222

223 224
export CXXFLAGS LDFLAGS

225
cd "$WORKING_DIR"/.. && ./configure $CONFIGURE_ARGS &&
226
  cd src && make clean && make $MAKE_TARGET &&
227
  cd "$WORKING_DIR" && mkdir -p target &&
228
  cp ../src/$MAKE_TARGET $TARGET_FILE ||
Kun Zhang's avatar
Kun Zhang committed
229 230 231 232 233 234 235 236
  exit 1

if [[ "$OS" == osx ]]; then
  # Since Mac linker doesn't accept "-s", we need to run strip
  strip $TARGET_FILE || exit 1
fi

checkArch $TARGET_FILE && checkDependencies $TARGET_FILE